<?php

$iColumns = 2;

if( basename( $_SERVER['PHP_SELF'] ) != 'admin.php' ){
  /**
  * Display product list in columns, depending on the number set above ($iColumns)
  * @return string
  * @param string $sFile
  * @param array  $aData
  * @param string $sPage
  * @param int    $iList
  */
if( !function_exists( 'throwProductsData' ) ){
  function throwProductsData( $sFile, $aData, $sPage, $iList ){
    global $tpl, $aList, $oFF;
    
    $sFile        = 'productsInRow.tpl'; 
    $aPhoto       = throwFirstPhoto( 1 );
    $iCount       = count( $aData );
    $content      = null;
    $iColumns     = $GLOBALS['iColumns'];
    $aCategories  = throwProductsCategories( );

    $aList['iWidth']    = (int) ( 100 / $iColumns );

    for( $i = 0; $i < $iCount; $i++ ){  
      list( $aList['iProduct'], $aList['sName'], $aList['fPrice'], $aList['sDescriptionShort'], $aList['iStatus'], $aList['iPosition'] ) = $aData[$i];
  
      if( $i > 0 && $i % $iColumns == 0 )
        $content .= $tpl->tbHtml( $sFile, 'TR' );
  

      if( isset( $aPhoto[$aList['iProduct']] ) && is_file( DIR_PRODUCTS_FILES.$aPhoto[$aList['iProduct']]['sPhoto'] ) ){
        $aName = $oFF->throwNameExtOfFile( $aPhoto[$aList['iProduct']]['sPhoto'] );
        $aList['sFile']       = $aPhoto[$aList['iProduct']]['sPhoto'];
        $aList['sPhotoSmall'] = DIR_PRODUCTS_FILES.$aName[0].'_m.'.$aName[1];
        $aList['sPhotoBig']   = DIR_PRODUCTS_FILES.$aPhoto[$aList['iProduct']]['sPhoto'];
        $aList['sPhoto']      = $tpl->tbHtml( $sFile, 'PHOTO' );    
      }
      else{
        $aList['sPhoto'] = null;
      }
  
      if( empty( $aList['sDescriptionShort'] ) )
        $aList['sDescriptionShort'] = '&nbsp;';
      else
        $aList['sDescriptionShort'] = ereg_replace( '\|n\|', '', $aList['sDescriptionShort'] );

      $aList['sCategories'] = throwTreeForProduct( $aCategories[$aList['iProduct']], $sFile );

      $content .= $tpl->tbHtml( $sFile, 'LIST_LIST' );
  
    } // end for
    
    while( $i == 0 || $i % $iColumns > 0 ){
      $content .= $tpl->tbHtml( $sFile, 'TD' );
      $i++;
    } // end while  
  
    $aList['sPages'] = countPages( $aData[0]['iFindAll'], $iList, $GLOBALS['iPage'], $sPage );
    return $tpl->tbHtml( $sFile, 'LIST_HEAD' ).$content.$tpl->tbHtml( $sFile, 'LIST_FOOT' );
  } // end function throwProductsData
}
}
?>
